%div.layout-body
  %div.container
    %div.row
      %div.col-lg-4.room-stasion
        %h3 Broadcast Menu
        %p *Copy Url to Share With Other
        %hr
        %select{:id => "broadcasting-option", :class=> "form-control"}
          %option Audio + Video
          %option Screen
          %input{:id => "broadcast-username", :class => "form-control", :placeholder => "Who I'am"}
          %input{:type => "text", :id => "broadcast-name", :class => "form-control", :placeholder => "Theme Broadcast"}
          %button{:id => "setup-new-broadcast", :class => "btn btn-primary"} Setup New Broadcastss
          %br
          %a{:href => "JavaScript: location.reload(true);"}
            Refresh

        %h3 Room List
        %hr
        %table{:style => "width: 100%;", :id => "rooms-list"}
      %div.col-lg-8.room-stasion
        %div{:id => "videos-container"}
:javascript
  var config = {
      openSocket: function(config) {
          var channel = config.channel || location.href.replace( /\/|:|#|%|\.|\[|\]/g , '');
          var socket = new Firebase('https://blistering-fire-4926.firebaseio.com/' + channel);
          socket.channel = channel;

          socket.on("child_added", function(data) {
              config.onmessage && config.onmessage(data.val());
              console.log(config.onmessage);
              console.log(config.onmessage(data.val()));
          });

          // push data channel to firbase.io
          socket.send = function(data) {
              this.push(data);
          };
          //console.log(config.onmessage);
          //console.log(config.onopen);
          config.onopen && setTimeout(config.onopen, 1);
          //console.log(socket.onDisconnect());
          socket.onDisconnect().remove();
          //console.log(socket);
          return socket;
      },
      onRemoteStream: function(htmlElement) {
          htmlElement.setAttribute('controls', true);
          videosContainer.insertBefore(htmlElement, videosContainer.firstChild);
          htmlElement.play();
          //rotateInCircle(htmlElement);
      },
      onRoomFound: function(room) {
          var alreadyExist = document.querySelector('button[data-broadcaster="' + room.broadcaster + '"]');
          if (alreadyExist) return;

          if (typeof roomsList === 'undefined') roomsList = document.body;

          var tr = document.createElement('tr');
          tr.innerHTML = '<td><strong>' + room.roomUser + '</strong> start broadcasting his media! (<strong>'+room.roomName+'</strong>)</td>' +
              '<td><button class="join">Join</button></td>';
          roomsList.insertBefore(tr, roomsList.firstChild);

          var joinRoomButton = tr.querySelector('.join');
          joinRoomButton.setAttribute('data-broadcaster', room.broadcaster);
          joinRoomButton.setAttribute('data-roomToken', room.broadcaster);
          joinRoomButton.onclick = function() {
              this.disabled = true;

              var broadcaster = this.getAttribute('data-broadcaster');
              var roomToken = this.getAttribute('data-roomToken');
              broadcastUI.joinRoom({
                  roomToken: roomToken,
                  joinUser: broadcaster
              });
              //hideUnnecessaryStuff();
          };
      },
      onNewParticipant: function(numberOfViewers) {
          document.title = 'Viewers: ' + numberOfViewers;
      }
  };

  function setupNewBroadcastButtonClickHandler() {
      document.getElementById('broadcast-name').disabled = true;
      document.getElementById('setup-new-broadcast').disabled = true;

      captureUserMedia(function() {
          var shared = 'video';
          if (window.option == 'Screen') shared = 'screen';
          broadcastUI.createRoom({
              roomName: (document.getElementById('broadcast-name') || { }).value || 'Anonymous',
              roomUser: (document.getElementById('broadcast-username')|| { }).value || 'Anonymous',
              isAudio: shared === 'audio'
          });
      });
      //hideUnnecessaryStuff();
  }

  function captureUserMedia(callback) {
      var constraints = null;
      window.option = broadcastingOption ? broadcastingOption.value : '';
      if (option === 'Only Audio') {
          constraints = {
              audio: true,
              video: false
          };
      }
      if (option === 'Screen') {
        var video_constraints = {
          mandatory: {
            chromeMediaSource: 'screen'
          },
          optional: []
        };
        constraints = {
          audio: false,
          video: video_constraints
        };
      }

      var htmlElement = document.createElement(option === 'Only Audio' ? 'audio' : 'video');
      htmlElement.setAttribute('autoplay', true);
      htmlElement.setAttribute('controls', true);
      videosContainer.insertBefore(htmlElement, videosContainer.firstChild);

      var mediaConfig = {
          video: htmlElement,
          onsuccess: function(stream) {
              config.attachStream = stream;
              callback && callback();
              htmlElement.setAttribute('muted', true);

          },
          onerror: function() {
            if (option === 'Only Audio') alert('unable to get access to your microphone');
            else if (option === 'Screen') {
              if (location.protocol === 'http:') alert('Please test this WebRTC experiment on HTTPS.');
              else alert('Screen capturing is either denied or not supported. Are you enabled flag: "Enable screen capture support in getUserMedia"?');
            } else alert('unable to get access to your webcam');
          }
      };
      console.log(mediaConfig.constraints);
      if (constraints) mediaConfig.constraints = constraints;
      console.log(constraints);

      getUserMedia(mediaConfig);
  }

  var broadcastUI = broadcast(config);

  /* UI specific */
  var videosContainer = document.getElementById('videos-container') || document.body;
  var setupNewBroadcast = document.getElementById('setup-new-broadcast');
  var roomsList = document.getElementById('rooms-list');

  var broadcastingOption = document.getElementById('broadcasting-option');
  if (setupNewBroadcast) setupNewBroadcast.onclick = setupNewBroadcastButtonClickHandler;
